#include <unistd.h>
void OnlyPlot()
{
TCanvas *c1 = new TCanvas("c1", "Jittering Measurements", 800, 600);
TCanvas *c2 = new TCanvas("c2", "Jittering Histograms", 800, 600);
TCanvas *c3 = new TCanvas("c3", "Jittering Histograms2", 800, 600);


char FileName[50] = "DataBACKUP.txt";
//See the columns configuration in FileName

std::ifstream infile(FileName);

	int count = 0;
	while( infile.good() )
	{
		char FileName[50] = "DataBACKUP.txt";
		//See the columns configuration in FileName
		TGraph *G1 = new TGraph(FileName, "%lg %lg");

		c1->cd();
		G1->Draw("AC*");
		c1->Update();
		
		c2->cd();
		double *X = G1->GetY();
		int N = G1->GetN();
		TH1F *h1 = new TH1F("h1", "Jittering Histogram",50, 270, 330 );
		TH1F *h2 = new TH1F("h2", "Jittering Histogram",250, 0, 500 );
		
		double x0 = 0 ;
		double x1 = 0;
		double Threshold = 10000;
		for(int y = 1; y < N; y++)
		{
			if( (X[y-1] < X[y])&&(X[y] > X[y+1])&&(y>x0) )
			{
				x1 = y;

				if(x0 > 0)
				{
					double Increase1 = X[x1] - X[x1-1];
					double Fraction1 = Threshold - X[x1-1];

					double Increase0 = X[x0] - X[x0-1];
					double Fraction0 = Threshold - X[x0-1];

					double Delta = (x1 + Fraction1/Increase1) - (x0 + Fraction0/Increase0);

					h1->Fill(Delta);
					h2->Fill(Delta);
				}
				x0 = x1;
			}
		}
		h1->Draw();
		c3->cd();
		h2->Draw();
		
		c1->cd();
		TF1 *f1 = new TF1("f1", "gaus", -50, 150);
        //h1->Fit("f1", "QR");
        f1->SetLineColor(kRed);
        f1->Draw("same");
		c2->Update();
		count++;
		if(count > 0)
		{
			char title1[50];
			sprintf(title1,"%s%s",c1->GetName(),".png");
			char title2[50];
			sprintf(title2,"%s%s",c2->GetName(),".png");
			
			c1->Print(title1);
			c2->Print(title2);
			return;
		}
		delete G1;
		delete h1;
		delete f1;
		usleep(1000*1000*60);
		cout<<count<<endl;

	}
}
